<!DOCTYPE html>
<html>
<head>
	<title>Exam 2</title>
	<style>
		.active {
			color: red;
		}
	</style>
</head>
<body>
	<div id="app">
		<h3>{{ message }}</h3>
		<send-message inline-template>
			<div>
				<div class="flash-message" v-if='isDeleted' v-bind:class="{active: isDeleted}">
					Nội dung bị xóa là: {{ deleteMessage }}
				</div>

    			<textarea v-model='message'></textarea>
    			<button @click='send'>Send</button>

    			<receive-message v-bind:message.sync="messageSend" 
    				v-on:notify-delete="getNotifyDelete"></receive-message>
    		</div>
		</send-message>
		
	</div>


	<script src="https://cdn.jsdelivr.net/npm/vue"></script>
    <script>
    	// Component So 01 (Parent)
    	Vue.component('send-message', {
    		data() {
    			return {
    				message: '',
    				isDeleted: false,
    				deleteMessage: '',
    				messageSend: '',
    			}
    		},
    		watch: {
    			messageSend(message) {
    				this.messageSend = message;
    			}
    		},
    		methods: {
    			send() {
    				this.messageSend = this.message
    			},
    			getNotifyDelete(message) {
    				this.isDeleted = true;
    				this.deleteMessage = message.content
    			}
    		},
    	})


    	// Component So 02 (Children)
    	Vue.component('receive-message', {
    		data() {
    			props: ['message']
    			return {
    				messages: [
    					{
    						content: 'Nội dung chat 1'
    					},
    					{
    						content: 'Nội dung chat 2'
    					},
    				],
    			}
    		},
    		watch: {
    			message(message) {
    				console.log(message)
    			}
    		},
    		methods: {
    			deleteMessage(index, message) {
    				this.messages.splice(index, 1)
    				this.$emit('notify-delete', message);
    			}
    		},
    		template: `<div>
    			<h3>Chat</h3>
    			<p v-for='(message, key) in messages'>
    				{{ message.content }}
    				<a href='#' style="color: red;" 
    					@click='deleteMessage(key, message)'>Delete</a>
    			</p>
    		</div>`,
    	})


    	new Vue({
    		el: '#app',
    		data: {
    			message: 'Học Vue JS',
    			menuTops: [
    				{
    					id: 1,
    					name: 'Home'
    				},
    				{
    					id: 2,
    					name: 'About'
    				},
    				{
    					id: 3,
    					name: 'Services'
    				},
    				{
    					id: 4,
    					name: 'Products'
    				},
    			],
    			menuRights: [
    				{
    					id: 1,
    					name: 'Laptop'
    				},
    				{
    					id: 2,
    					name: 'Desktop'
    				},
    				{
    					id: 3,
    					name: 'Mobile'
    				},
    				{
    					id: 4,
    					name: 'Camera'
    				},
    				{
    					id: 5,
    					name: 'Printer'
    				},
    			],
    		}
    	})
    </script>
</body>
</html>